﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.IRA
@{
    ViewData["Title"] = "Index";
}
<style>
    .panel-title a {
        line-height: 30px;
    }

    tr td:first-child {
        text-align: left;
    }

    .backtolist {
        margin-top: -33px !important;
    }
</style>
<script>
    $(document).ready(function () {
        var tsum = 0;
        var tcount = 0;
        $('#accordion').html($('#HtmlCode').val());
        $('.panel-default').each(function (i, ele) {
            var SubDomainId = $(ele).find(".panel-heading").attr("id").split('_')[1];
            var DomainCompilancescore = $(ele).find('#DomainComScore' + SubDomainId).val();
            if (DomainCompilancescore.replace('%', '') < 60) {
                (DomainCompilancescore.replace('%', '') == "" ? $('#DomainComScore' + SubDomainId).css({ 'background-color': '#fff', 'color': '#fff' }): $('#DomainComScore' + SubDomainId).css({ 'background-color': '#f4c2c2', 'color': '#FFFFFF' }));
            } else if (DomainCompilancescore.replace('%', '') >= 60 && DomainCompilancescore.replace('%', '') < 80) {
                $('#DomainComScore' + SubDomainId).css({ 'background-color': '#ffff99', 'color': '#000000' });
            } else if (DomainCompilancescore.replace('%', '') >= 80 && DomainCompilancescore.replace('%', '') < 100) {
                $('#DomainComScore' + SubDomainId).css({ 'background-color': '#92d050', 'color': '#000000' });
            } else {
                $('#DomainComScore' + SubDomainId).css({ 'background-color': '#00b050 ', 'color': '#FFFFFF' });
            }
            var sum = parseFloat(DomainCompilancescore.replace('%', ''));
            if (isNaN(sum)) {
             sum = 0;
            }
            tsum = tsum + sum;
            tcount += 1;
        })
        var avg = parseFloat(tsum / tcount).toFixed(2);
        $('#OverallCompScore').val(avg + '%');
    });
    function fn_bindOverallEffectiveness(input) {
        debugger
        if ($(input).val() == 1) {
            $(input).parent().parent().find('td:eq(4) input[type="text"]').val('NA');
            $(input).parent().parent().find('td:eq(3) select').val(0);
            $(input).parent().parent().find('td:eq(3) select').prop('disabled', true);
        } else if ($(input).val() == 3) {
            $(input).parent().parent().find('td:eq(4) input[type="text"]').val('Not Effective');
            $(input).parent().parent().find('td:eq(3) select').val(0);
            $(input).parent().parent().find('td:eq(3) select').prop('disabled', true);
        } else if ($(input).val() == 2) {
            $(input).parent().parent().find('td:eq(3) select').prop('disabled', false);
            var ChildID = $(input).parent().parent().find('td:eq(3) option:selected').val();
            if (ChildID == 2) {
                $(input).parent().parent().find('td:eq(4) input[type="text"]').val('Effective');
            } else if (ChildID == 3) {
                $(input).parent().parent().find('td:eq(4) input[type="text"]').val('Partially Effective');
            } else {
                $(input).parent().parent().find('td:eq(4) input[type="text"]').val('');
            }
        } else {
            $(input).parent().parent().find('td:eq(3) select').val(0);
            $(input).parent().parent().find('td:eq(4) input[type="text"]').val('');
        }
    }
    function fn_bindOverallEffectiveness2(input) {
        var parentID = $(input).parent().parent().find('td:eq(2) option:selected').val();
        if (parentID == 2) {
            if ($(input).val() == 3) {
                $(input).parent().parent().find('td:eq(4) input[type="text"]').val('Partially Effective');
            } else if ($(input).val() == 2) {
                $(input).parent().parent().find('td:eq(4) input[type="text"]').val('Effective');
            } else {
                $(input).parent().parent().find('td:eq(4) input[type="text"]').val('');
            }
        }
    }
    function Calc(input, SubDomainID) {
        debugger
        var Count = 0;
        var cEffective = 0;
        var cPartiallyEffective = 0;
        var cNA = 0;
        var table = "#tbl_" + SubDomainID;
        $(table + ' tbody tr').each(function (i, tr) {
            Count += 1;
            var Name = $(tr).find("td:eq(4) input[type=text]").val();
            if (Name == "Effective") {
                cEffective += 1;
            } else if (Name == "Partially Effective") {
                cPartiallyEffective += 1;
            } else if (Name == "NA") {
                cNA += 1;
            }
        });
        debugger
        var tcEffective = (cEffective * 5);
        var tcPartiallyEffective = (cPartiallyEffective * 3);
        var tCount = (Count - cNA);
        var finlaScore = (((tcEffective + tcPartiallyEffective) / tCount)) / 5;
        var Percentage = parseInt(finlaScore * 100);
        if (isNaN(Percentage)) {
            Percentage = 0;
        }
        if (Percentage < 60) {
            $('#DomainComScore' + SubDomainID).css({ 'background-color': '#f4c2c2', 'color': '#FFFFFF' });
        } else if (Percentage >= 60 && Percentage < 80) {
            $('#DomainComScore' + SubDomainID).css({ 'background-color': '#ffff99', 'color': '#000000' });
        } else if (Percentage >= 80 && Percentage < 100) {
            $('#DomainComScore' + SubDomainID).css({ 'background-color': '#92d050', 'color': '#000000' });
        } else {
            $('#DomainComScore' + SubDomainID).css({ 'background-color': '#00b050 ', 'color': '#FFFFFF' });
        }
        $('#DomainComScore' + SubDomainID).val(Percentage + '%');
        OverallComp();
    }
    function fn_saveAssessment(IsTask) {
        var FinalXML = [];
        $('.panel-default').each(function (i, ele) {
            var ControlTableArray = [];
            var SubDomainId = $(ele).find(".panel-heading").attr("id").split('_')[1];
            var DomainCompilancescore = $(ele).find('#DomainComScore' + SubDomainId).val();
            var sn = 0;
            $(ele).find('#tbl_' + SubDomainId + ' tbody tr').each(function (iProc, eletr) {
                var ICDID = $(eletr).find('td:eq(0) input[type=hidden]').val();
                var SubDomainID = $(eletr).find('td:eq(1) input[type=hidden]').val();
                var controlName = $(eletr).find('td:eq(0)').text();
                var controlDescription = $(eletr).find('td:eq(1)').text();
                var Testofdesign = $(eletr).find('td:eq(2) option:selected').val();
                var Testofeffectiveness = $(eletr).find('td:eq(3) option:selected').val();
                var overalleffectiveness = $(eletr).find('td:eq(4) input[type="text"]').val();
                var remarks = $(eletr).find('td:eq(5) input[type="text"]').val();
                ControlTableArray[sn] = {
                    ICDID: ICDID,
                    SubDomainID: SubDomainID,
                    controlName: controlName,
                    controlDescription: controlDescription,
                    Testofdesign: Testofdesign,
                    Testofeffectiveness: Testofeffectiveness,
                    overalleffectiveness: overalleffectiveness,
                    remarks: remarks,
                }
                sn++;
            })
            FinalXML[i] = {
                DomainCompilancescore: DomainCompilancescore,
                xml: ControlTableArray.length > 0 ? ControlTableArray : null
            }
        })
        var model = {
            OrgId: $("#OrgId").val(),
            xmlPerformAssessment: JSON.stringify(FinalXML)
        }
        $.post('/ApplicationManagement/ComplainceAssessmentRCM/SubmitComplainceAssessmentRCM', { model: model }, function (res) {
            if (IsTask == "True") {
                $.get('/Dashboard/Landing/GovernanceReports', (res) => $('#ajaxresult').html(res))
                toastr.success('Task completed!');
            } else {
                $.get('/ApplicationManagement/ComplainceAssessmentRCM/TabMenu', { orgId: $("#OrgId").val(), orgName: $("#OrgName").val() }, (res) => $('#ajaxresult').html(res))
                res.isSuccess ? toastr.success('Saved successfully.') : toastr.error('Something went wrong!');
            }
           
        })
    }
    function OverallComp() {
        var tsum = 0;
        var tcount = 0;
        $('.panel-default').each(function (i, ele) {
            debugger
            var SubDomainId = $(ele).find(".panel-heading").attr("id").split('_')[1];
            var DomainCompilancescore = $(ele).find('#DomainComScore' + SubDomainId).val();
            var sum = parseFloat(DomainCompilancescore.replace('%', ''));
            if (isNaN(sum)) {
                sum = 0;
            }
            tsum = tsum + sum;
            tcount += 1;
        })
        debugger
        var avg = parseFloat(tsum / tcount).toFixed(2);
        $('#OverallCompScore').val(avg + '%');
          }
   
</script>

<section>
    @Html.HiddenFor(m => m.HtmlCode)
    @Html.HiddenFor(m => m.xmlPerformAssessment)
    @Html.HiddenFor(m => m.OrgId)
    @Html.HiddenFor(m => m.OrgName)
    <div class="right_section">
        <div class="pb-2 mt-3 mb-3 border-bottom box_title pl-4">
            Compliance against @Model.OrgName
            <div style="margin-top:-28px">
                <label style="margin-left:562px;font-size:14px">Overall compliance score</label>
                <input id="OverallCompScore" type="text" disabled="disabled" style='text-align: center;' />
            </div>
            @if (Model.IsTask)
            {
                <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="GovernanceReports" asp-controller="Landing" asp-area="Dashboard" asp-route-orgId="@Model.OrgId" asp-route-orgName="@Model.OrgName">Back to Menu</a>

            }
            else
            {
                <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="TabMenu" asp-controller="ComplainceAssessmentRCM" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-orgName="@Model.OrgName">Back to Menu</a>

            }
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="panel-group" id="accordion" role="tablist" aria-multiselectable="false">

                    </div>
                    <div>
                        
                        <input type="submit" class="btn btn-primary pull-right" onclick="return fn_saveAssessment('@Model.IsTask')" value="Save" style="margin-right: 10px;" />
                        <input type="submit" class="btn btn-primary pull-right" onclick="return fn_submitAssessment()" value="Submit" style="visibility: hidden;" />
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>